-- 今日收获
Lua_HarvestPackWindow = class("Lua_HarvestPackWindow", Lua_Window);
function Lua_HarvestPackWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HarvestPackWindow";
	self.skinName = "HarvestPackWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -540;
end

function Lua_HarvestPackWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.onHarvestNum = 0;
	self.harvestDragList = Lua_DragList.new(self.content, 570, 632, Lua_AxisDefine.Vertical);
	self.harvestDragList:setListCell(Lua_HarvestItem, 190, 316, 3);
	self.harvestDragList:setLocation(0, 15, 0);
	self.subBtn:setGray(true);
	self.subBtn:addClickFuntion(self, self.onSubBtnClick); -- 一键翻牌

	self:addLuaEvent("ON_HORT_ITEM", self, self.onHortItem); -- 点击伤害统计，向服务端发送数据 DagList的cell元素
	self:addLuaEvent("ON_HARVEST_ITEM", self, self.onHarvestItem); -- 点击翻牌，向服务端发送数据 DragList的cell元素
	self:addLuaEvent("UPDATE_SUBBTN_STATE", self, self.updateSubBtnState); -- 更新一键翻牌按钮的状态 DragList的cell元素
	self:addLuaEvent("UPDATE_HARVEST_INFO", self, self.updateHarvestInfo);
end

function Lua_HarvestPackWindow:showWin(param)
	self:superCall("showWin",param);

	-- param 1：单人 2：队伍
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sHarvest(param);
end

function Lua_HarvestPackWindow:updateHarvestInfo()
	self:updateSubBtnState(); -- 更新一键翻牌按钮的状态
	self:showDrawInfo(); -- 更新draglist
end

-- 更新一键翻牌按钮的状态
function Lua_HarvestPackWindow:updateSubBtnState(state)
	if state then
		self.onHarvestNum = self.onHarvestNum + 1;
	end
	self.isHavoHarvest = DataCenter.equipCopyData.isHavoHarvest;
	self.subBtn:setGray(not self.isHavoHarvest);
end

function Lua_HarvestPackWindow:showDrawInfo()
	self.harvestDragList:setArrayData(DataCenter.equipCopyData.harvestInfo);
end

function Lua_HarvestPackWindow:onHarvestItem(record_id)
	if self.subBtnState then
		if self.sendMsg == nil then -- 一键翻牌动画返回多次，这里只需要请求一次就可以了
			self.sendMsg = true;
			Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sReceiveReward(self.showData, 0);
		end
	else
		Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sReceiveReward(self.showData, record_id);
	end
	self.onHarvestNum = self.onHarvestNum - 1;
end

function Lua_HarvestPackWindow:onHortItem(record_id)
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sLookHort(self.showData, record_id);
end

-- 点击一键翻牌时，所有卡牌的反转特效
function Lua_HarvestPackWindow:onSubBtnClick()
	self:updateSubBtnState(); -- 更新一键翻牌按钮的状态
	if self.isHavoHarvest == false then
		return;
	end

	self.subBtnState = true;
	self.harvestDragList.canDrag = false;
	Lua_CommonUtil.delayCall(0.6, self, self.updateListCanDrag);

	local list = self.harvestDragList.showList;
	local arr = DataCenter.equipCopyData.harvestInfo;
	for i = 1, list:getSize() do
		list[i]:onPressClick();
	end

	for i = 1, arr:getSize() do
		arr[i].is_overreturn = 1; 
	end
	self.subBtn:setGray(true);
end

function Lua_HarvestPackWindow:updateListCanDrag()
	self.harvestDragList.canDrag = true;
end

function Lua_HarvestPackWindow:onMaskClick(go)
	if self.onHarvestNum > 0 then
		return
	end

	self:hide();
end

function Lua_HarvestPackWindow:dispose()
	if self.harvestDragList ~= nil then
		self.harvestDragList:dispose()
		self.harvestDragList = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.updateListCanDrag);
	self:superCall("dispose");
end










Lua_HarvestItem = class("Lua_HarvestItem", Lua_ListCell);
function Lua_HarvestItem:ctor(p)
	self:superCall("ctor", p, "HarvestItem_skin");
end

function Lua_HarvestItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setCanClick(false);
	self.itemIcon:setLocation(-1.5, 37, 0);
	self.itemIcon:setScale(0.8, 0.8);

	self.hurtBtn:addClickFuntion(self, self.onHurtBtnClick);
end

function Lua_HarvestItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end
	self.fight_grade = data.data.fight_grade;
	self.isShowHarvest = data.is_overreturn == 1; -- true已翻牌 false未翻牌

	self.showIcon:setAltas("equipcopy_atlas_2","xui_jmd_label_"..6-self.fight_grade);
	self.showIcon:setEnable(true);
	self.showIcon:resetSize();
end

function Lua_HarvestItem.Get:isShowHarvest()
	if self._isShowHarvest == nil then
		return false;
	end
	return self._isShowHarvest;
end

function Lua_HarvestItem.Set:isShowHarvest(val)
	self._isShowHarvest = val;
	self:updateShowHarvest();
end

-- 更新展示结果
function Lua_HarvestItem:updateShowHarvest()
	if self.isShowHarvest == false then -- 未翻盘
		self.itemIcon:setEnable(false);
		self.itemNameTxt:setEnable(false);
		self:openItemBack(0);
	else
		local list = self.data.data.reward;
		if list ~= nil and #list > 0 then
			self.tvo = Lua_ToolVo.createToolVo(list[1].id, list[1].amount);
			self.itemIcon:setData(self.tvo);
			self.itemIcon:setEnable(true);

			self.itemNameTxt.text = self.tvo.name;
			self.itemNameTxt:setEnable(true);
			self:openItemBack(1);
		end
	end
end

function Lua_HarvestItem:onPressClick()
	local winPos = LuaUtil.getTouchPosInverseTf(self.mainContent.transform);
	if self.itemIcon.isActive and self.itemIcon:checkInBound(winPos.x, winPos.y) then
		DataCenter.packUtil:showItemInfo(self.tvo);
	end

	if self.data.is_overreturn == 1 then
		return;
	end
	self.data.is_overreturn = 1; -- 记录已翻牌
	Lua_MsgUtil.callFunc("UPDATE_SUBBTN_STATE",true); -- 更新一键翻牌按钮的状态

	self:onStartComplete(); -- 翻牌效果
end

function Lua_HarvestItem:onStartComplete()
	TweenUtil.getInstance():addTween(self.mainContent, 0.3, 0,
	self.x, self.y, 0,
	0, 0, 0,
	0, 1, 1,
	self, self.onAgainComplete, 0, false);
end

function Lua_HarvestItem:onAgainComplete()
	self:openItemBack(1);
	self.isShowHarvest = true;
	TweenUtil.getInstance():addTween(self.mainContent, 1, 0,
	self.x, self.y, 0,
	0, 0, 0,
	1, 1, 1,
	self, self.overComplete, 0, false);
end

function Lua_HarvestItem:overComplete()
	TweenUtil.getInstance():stop(self.mainContent);
	Lua_MsgUtil.callFunc("ON_HARVEST_ITEM", self.data.data.record_id);
end

function Lua_HarvestItem:onHurtBtnClick()
	Lua_MsgUtil.callFunc("ON_HORT_ITEM", self.data.data.record_id);
end

-- 翻牌返回
function Lua_HarvestItem:openItemBack(val)
	if val == 0 then
		self.bg:setAltas("equipcopy_atlas_3","xui_jmd_window_0"..(11+self.fight_grade));
	else
		self.bg:setAltas("equipcopy_atlas_3", "xui_jmd_window_009");
	end
end

function Lua_HarvestItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose()
		self.itemIcon = nil;
	end
	TweenUtil.getInstance():stop(self.mainContent);

	self:superCall("dispose");
end