-- 被邀请界面
Lua_ECInvitationJournalWindow = class("Lua_ECInvitationJournalWindow", Lua_Window);
function Lua_ECInvitationJournalWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ECInvitationJournalWindow";
	self.skinName = "EquipCopyInvitationJournalWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ECInvitationJournalWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.journalContainer = Lua_DragContainer.new(self.content, 654, 718, Lua_AxisDefine.Vertical);
	self.journalContainer:setCellSpacing(0, 3);
	self.journalContainer:setLocation(0, -59, 0);

	self:addLuaEvent("EQUIP_COPY_TEAM_INVITATION_JOURNAL", self, self.updatePanel);
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sLockInvite();
	DataCenter.equipCopyData:updateTeamInviteRedDot(false);
end

function Lua_ECInvitationJournalWindow:showWin(param)
	self:superCall("showWin", param);
end

function Lua_ECInvitationJournalWindow:updatePanel(isChange)
	local journalList = DataCenter.equipCopyData.invitationJournalList;
	if #journalList == 1 and journalList[1].type == 1 then -- type：0为正常服务端数据 1为无数据 2为昨日记录
		self.noneObj:SetActive(true);
		self.journalContainer:setEnable(false);
		return;
	else
		self.noneObj:SetActive(false);
		self.journalContainer:setEnable(true);
	end

	self.journalContainer:clearList();
	for i = 1, #journalList do
		self.journalContainer:addSubContainer(Lua_ECInvitationJournalItem, journalList[i], false);
	end
	self.journalContainer:updateChildPos();
	if isChange == nil then
		self.journalContainer:moveToIndex(1, true);
	end
end

function Lua_ECInvitationJournalWindow:dispose()
	if self.journalContainer ~= nil then
		self.journalContainer:dispose();
		self.journalContainer = nil;
	end
	self:superCall("dispose");
end










Lua_ECInvitationJournalItem = class("Lua_ECInvitationJournalItem", Lua_DragContainerItem);
function Lua_ECInvitationJournalItem:ctor(p)
	self:superCall("ctor", p, "EquipCopyInvitationJournalItem_skin"); 
end

function Lua_ECInvitationJournalItem:buildShowItem()
	self:superCall("buildShowItem");

	self.canelBtn:setGray(true);
	self.sureBtn:addClickFuntion(self, self.onSendSureInfo);
	self.canelBtn:addClickFuntion(self, self.onSendCancelInfo);
end

function Lua_ECInvitationJournalItem:setData(data)
	if data == nil then
		return;
	end

	self.type = data.type; -- 记录类型
	self.teamId = data.teamId; -- 队伍id

	-- type：0为正常服务端数据 1为无数据 2为昨日记录
	if self.type == 2 then
		self.journalObj:SetActive(false);
		self.yesterdayObj:SetActive(true);
		self.yesterdayTxt.text = data.content;
		return;
	else
		self.journalObj:SetActive(true);
		self.yesterdayObj:SetActive(false);
	end

	-- 0 失效 1 有效
	self.sureBtn:setEnable(data.isValid == 1);
	self.canelBtn:setEnable(data.isValid == 1);
	self.invalidTxt:setEnable(data.isValid == 0);
	self.invalidTxt:setLangValue(420028);

	-- 时间
	self.timeTxt.text = data.time;
	self.logContentTxt.text = data.content;
end

function Lua_ECInvitationJournalItem:onSendSureInfo()
	if DataCenter.equipCopyData.team_id == 0 then
		self:sendIsInvite();
	else
		self:showTips();
	end
end

--是否切换队伍
function Lua_ECInvitationJournalItem:showTips()
	local tipsData = {
		type = 1,
		btnType = 1,
		des = LanUtil.getValue(420020),
		owner = self,
		sureFun = self.sendIsInvite};
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

-- 发送 接受邀请 消息号
function Lua_ECInvitationJournalItem:sendIsInvite()
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sIsInvite(self.teamId, 1);
	Lua_WindowUtil.openWin("Lua_ECInvitationJournalWindow", Lua_WinParam.ACTION_CLOSE);
end

-- 发送 拒绝邀请 消息号
function Lua_ECInvitationJournalItem:onSendCancelInfo()
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sIsInvite(self.teamId, 0);
end

function Lua_ECInvitationJournalItem:getWidth()
	return 654;
end

function Lua_ECInvitationJournalItem:getHeight()
	return self.type == 2 and 70 or 136;
end

function Lua_ECInvitationJournalItem:dispose()
	self:superCall("dispose");
end