-- 魔灵岛（寂灭岛）
checkRequire("Lua_SingleTeamPanel"); -- 单人
checkRequire("Lua_MoreTeamPanel"); -- 多人
Lua_EquipCopyWindow = class("Lua_EquipCopyWindow", Lua_Window);
function Lua_EquipCopyWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_EquipCopyWindow";
	self.layer = MainWinDefine.MAIN_MENU_TOP_LAYER;
	self.isFullSizeWin = true;
	self.showBackBtn = true;
	self.isSingleShowWin = true;
	self.bEquipCopyWindowShowWin = false;
end

function Lua_EquipCopyWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content)
    self.roleInfoPanel:setRectAnchor(1)

	self.btnListBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_widget_005", 0, 60.5, 720, 121);
	self.btnListBg.anchor = Lua_WindowUtil.getAnchor(7);
	self.btnListBg.siblingIndex = 0;

	self.panelObjTab = {};
	self.tabInfo = Array();
	self.tabInfo:add({panel = Lua_SingleTeamPanel, redPointId = Lua_RedPointList.EquipCopy_Single, textAtlas = "equipcopy_atlas_1", textNormalSprite = "xui_jmd_zgnbutton_01_n", textSelectedSprite = "xui_jmd_zgnbutton_01_p"});
	self.tabInfo:add({panel = Lua_MoreTeamPanel, redPointId = Lua_RedPointList.EquipCopy_Team, textAtlas = "equipcopy_atlas_1", textNormalSprite = "xui_jmd_zgnbutton_02_n", textSelectedSprite = "xui_jmd_zgnbutton_02_p"});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList.pivot = -1;
	self.btnList:setRectAnchor(7);
	self.btnList:setLocation(252, 59, 0);
	self.btnList:setButtonStyle("common_altas_1", "xui_common_zgnbutton_07", "xui_common_zgnbutton_07", 108, 118, 0.01, 1);
	self.btnList:setButtonLine("common_altas_1", "ui_common_line_011", 2, 108, 0, 0, 1);
	self.btnList:setButtonItem(108, 118);
	self.btnList:setRedPoint(42, 41);
	self.btnList:setClickCallBack(self, self.onTabBtnClick);
	self.btnList:setData(self.tabInfo);

	self:updateTeamSelect();
	self:addLuaEvent("EQUIP_COPY_SHOW_MODEL", self, self.showModel); -- 展示模型
	self:addLuaEvent("EQUIP_COPY_OPEN_TEAM", self, self.updateTeamSelect); -- 是否能打开组队页签
	-- self:addLuaEvent("EQUIP_COPY_INFO", self, self.updateEquipCopyInfo);

	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sFirstPassRankInfo(); -- 排行榜按钮红点显示
end

function Lua_EquipCopyWindow:showWin(param)
	self.bEquipCopyWindowShowWin = true;
	self:superCall("showWin", param);

	local index = 1;
	if param.main_id ~= nil then -- 外部打开
		index = param.main_id;
	end

	if param.modelScenePanel then
		if self.modelScenePanel ~= nil and self.modelScenePanel ~= param.modelScenePanel then
			self.modelScenePanel:dispose();
			self.modelScenePanel = nil;
		end

		self.modelScenePanel = param.modelScenePanel;
		self.modelScenePanel:setParent(self.content)
		self.modelScenePanel:setRotBgDimensions(720, 720)
		self.modelScenePanel:setRotBgPos(0, 130)
		param.modelScenePanel = nil
	end

	if self.boos_id ~= nil then self:showModel(self.boos_id); end
	self.singleTabSelect = param.tab_select;--默认选中的单人副本页签id
	self.btnList:setSelected(index);

	if index == 2 and self.singleTabSelect == nil and self.isSatisfyDiff then--主动打开组队界面
		local index = 1;--打开组队大厅
		if (DataCenter.equipCopyData.reward_times > 0 or DataCenter.equipCopyData.help_times >0) and
		 DataCenter.equipCopyData.team_id ~= 0  then-- 次数充足/没有被踢出队伍--打开组队界面
			index = 2;
		end
		Lua_WindowUtil.openWin("Lua_TeamSaloonWindow", Lua_WinParam.ACTION_OPEN, index);
	end
end

-- 组队页签是否开启
function Lua_EquipCopyWindow:updateTeamSelect()
	self.isSatisfyDiff = DataCenter.equipCopyUtil.bOpeneMoreTeam -- 是否已通关对应配置难度
	self.btnList:setOpenState(2, self.isSatisfyDiff);
end 

-- -- 更新页签数据
-- function Lua_EquipCopyWindow:updateEquipCopyInfo()
-- 	if self.panel ~= nil and self.panel.updateShowInfo ~= nil then
-- 		self.panel:updateShowInfo();
-- 	end
-- end

function Lua_EquipCopyWindow:onTabBtnClick(val)
	if val == 2 and not self.isSatisfyDiff then
		if not DataCenter.equipCopyUtil.teamOpenState then
			OperateAlert.showLangValue(420011);
		elseif not DataCenter.equipCopyUtil.bOpeneTeamDifficulty then
			local id = DataCenter.equipCopyData.copyOpenId * 1000 + DataCenter.equipCopyUtil.create_team_cond;
			local data = DataCenter.equipCopyUtil:getSingleCapyVoById(id);
			OperateAlert.show(LanUtil.formateStr(420000, data.name));
		end
		self.btnList:setSelected(1);
		return;
	end
	if self.selectTabIndex == val then
		return
	end

	-- 隐藏旧的
	self.panel = self.panelObjTab[self.selectTabIndex];
	if self.panel ~= nil then
		self.panel:setEnable(false);
	end
	self.selectTabIndex = val;
	self.panel = self.panelObjTab[val];
	if self.panelObjTab[val] == nil then
		self.panel = self.tabInfo[val].panel.new(self.content);
		self.panel:setSiblingIndex(0);
		self.panel:setRectAnchor(9);
		self.panelObjTab[val] = self.panel;
	end
	self.panel:setEnable(true);

	if self.panel.updateCopyInfo ~= nil then
		self.panel.tab_select = self.singleTabSelect;
		self.panel:updateCopyInfo();
	end

	if self.tweenName ~= nil then
		DataCenter.winTweenManager:removeWinTween(self.tweenName);
	end
	self.tweenName = DataCenter.winTweenManager:createWinTween(self.panel.content.name, self.content.transform);
end

-- 模型展示
function Lua_EquipCopyWindow:showModel(boos_id)
	self.boos_id = boos_id;
	local mondelData = Lua_MonsterConfigData.getMonsterConfig(boos_id);
	if mondelData == nil then
		if self.modelScenePanel ~= nil then
			self.modelScenePanel:setModelEnable(false);
		end
		return
	end

	if not self.bEquipCopyWindowShowWin then
		return;
	end
	
	local heroVo = mondelData.heroVo;
	if self.modelScenePanel == nil then
		self.modelScenePanel = Lua_ModelScenePanel.new();
		self.modelScenePanel:setParent(self.content);
		self.modelScenePanel:setRotBgDimensions(720, 720);
		self.modelScenePanel:setRotBgPos(0, 130);
	end

	self.modelScenePanel.rotBg.siblingIndex = 0;
	local sceneId = self.selectTabIndex == 1 and Lua_EquipCopyUtil.moreSceneId or Lua_EquipCopyUtil.singleSceneId;
	self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UIWAIT, heroVo.poseActEffs);
	self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UISHOW, heroVo.showActEffs);
	self.modelScenePanel:showModelScene(sceneId, heroVo.uiModelUrl, heroVo.uiModelAvatarName, heroVo.uiModelCamController)
	self.modelScenePanel:setModelAct(heroVo.uiShowAct, Lua_ThingDefine.UIWAIT, true);
	self.modelScenePanel:setModelDir(heroVo.uiModelDir);
	self.modelScenePanel:setModelScale(heroVo.uiModelScale);
end

function Lua_EquipCopyWindow:onBackBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1035, true);
end

function Lua_EquipCopyWindow:resetActive(bActive)
    self:superCall("resetActive", bActive);
    if bActive then -- 显示
        if self.boos_id ~= nil then
            self:showModel(self.boos_id);
        end
    else
        if self.modelScenePanel ~= nil then
            self.modelScenePanel:dispose();
            self.modelScenePanel = nil;
        end
    end
end

function Lua_EquipCopyWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.tabInfo ~= nil then
		self.tabInfo:dispose();
		self.tabInfo:clear();
		self.tabInfo = nil;
	end
	if self.panelObjTab ~= nil then
		for idx, panelObj in pairs(self.panelObjTab) do
			panelObj:dispose();
			panelObj = nil;
		end
		self.panelObjTab = nil;
	end

	if self.modelScenePanel ~= nil then
		self.modelScenePanel:dispose()
		self.modelScenePanel = nil
	end

	if self.roleInfoPanel then
		self.roleInfoPanel:dispose()
		self.roleInfoPanel = nil
	end
	DataCenter.winTweenManager:removeWinTween(self.tweenName);
	self:superCall("dispose");
end