-- 单人关卡难度
Lua_SingleCopyCell = class("Lua_SingleCopyCell", Lua_ListCell);
function Lua_SingleCopyCell:ctor(p)
	self:superCall("ctor", p, "SingleCopyCell_skin");
end

function Lua_SingleCopyCell:buildShowItem()
	self:superCall("buildShowItem");

	self.subDragList = Lua_DragList.new(self.content, 425, 100, Lua_AxisDefine.Horizontal);
	self.subDragList:setListCell(Lua_SingleRewardCell, 100, 100, 1);
	self.subDragList:setCellSpacing(3, 0);
	self.subDragList:setSiblingIndex(5);
	self.subDragList:setRectPivot(3);
	self.subDragList:setLocation(-263.5, -16);
	self:setSubList(self.subDragList);

	self.challengeBtn:setBgScale(0.8, 0.8, 0.8);
	self.challengeBtn:addClickFuntion(self, self.onChallengeBtnClick)
end

function Lua_SingleCopyCell:setData(data)
	self.data = DataCenter.equipCopyUtil:getSingleCapyVoById(data.id);
	if self.data == nil then
		return;
	end

	self.difficultyTxt.text = LanUtil.formateStr(420039, self.data.name);

	local curUnlockDiff = DataCenter.equipCopyData:getCopyDifficultyByID(self.data.camp); -- 当前解锁的难度
	local isShow;
	local maxDiff = DataCenter.equipCopyUtil:getSingleDiffCountByCamp(self.data.camp);
	if curUnlockDiff >= maxDiff or curUnlockDiff <= 1 then
		isShow = curUnlockDiff == self.data.difficulty;
	else
		isShow = curUnlockDiff - 1 == self.data.difficulty;
	end
	self.tipsIcon:setEnable(isShow); -- 除了最低和最高难度，其他默认上一难度
	
	local list = self.data.reward_list;
	self.subDragList:setArrayData(list);
	self.subDragList.canDrag = #list > 4;

	local score = DataCenter.equipCopyUtil:getCopyScoreByGrade(self.data.pass_grade);
	self.tipsTxt.text = LanUtil.formateStr(420040, score);

	self.unlockState = curUnlockDiff >= self.data.difficulty;
	self.tipsObj:SetActive(curUnlockDiff < self.data.difficulty);
	self.challengeBtn:setGray(curUnlockDiff < self.data.difficulty);
end

function Lua_SingleCopyCell:onChallengeBtnClick()
	if self.unlockState == true then
		if DataCenter.equipCopyData.team_id ~= 0 then
			OperateAlert.showLangValue(420106);
			return
		end
		if DataCenter.equipCopyData.free_times > 0 then
			self:onChallengeCallBack();
		else
			local itemInfo = DataCenter.equipCopyUtil.single_boss_extra_item[1];--道具不足
			if DataCenter.packData:getItemCountById(itemInfo[1])<= 0 then
				DataCenter.packUtil:openPathWindow(itemInfo[1], false);
				return
			end

			if not DataCenter.neverTipData:getNeverValue(Lua_NeverTipDefine.EQUIPCOPY_SINGEL_CHALLENGE) then
				local itemInfo = DataCenter.equipCopyUtil.single_boss_extra_item[1];
				local str = spliceIconStrById(itemInfo[1]);
				local tipsData = {
					owner = self,
					neverTip = Lua_NeverTipDefine.EQUIPCOPY_SINGEL_CHALLENGE,
					posY = 32,
					des = LanUtil.formateStr(420041, tostring(itemInfo[2]), str),
					btnType = 1,
					font_size = 26,
					sureFun = self.onChallengeCallBack,
				};
				Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
			else
				self:onChallengeCallBack();
			end
		end
	else
		OperateAlert.showLangValue(420042);
	end
end

function Lua_SingleCopyCell:onChallengeCallBack()
	Lua_MsgUtil.callFunc("ON_SELECT_DIFF_FIGHT", {difficulty = self.data.difficulty, monster_player_id = self.data.boss_id, stage_id = self.data.id});
end

function Lua_SingleCopyCell:dispose()
	if self.subDragList ~= nil then
		self.subDragList:dispose();
		self.subDragList = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end










Lua_SingleRewardCell = class("Lua_SingleRewardCell", Lua_ListCell);
function Lua_SingleRewardCell:ctor(p)
	self:superCall("ctor", p);
end

function Lua_SingleRewardCell:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setScale(0.8, 0.8);
	self.itemIcon:setCanClick(false);
end

function Lua_SingleRewardCell:setData(list)
	if list == nil then
		return;
	end

	self.data = Lua_ToolVo.createToolVo(list[1], list[2]);
	self.itemIcon:setData(self.data);
end

function Lua_SingleRewardCell:onPressClick()
	if self.data == nil then
		return;
	end
	DataCenter.packUtil:showItemInfo(self.data);
end

function Lua_SingleRewardCell:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end