-- 单人
checkRequire("Lua_SingleCopyCell");
Lua_SingleTeamPanel = class("Lua_SingleTeamPanel", Lua_DisplayObject);
function Lua_SingleTeamPanel:ctor(p)
	self:superCall("ctor", p, "SingleTeamPanel_skin");
end

function Lua_SingleTeamPanel:buildShowItem()
	self:superCall("buildShowItem");
	self.campList = getConfig("equip_copy");

	-- 关卡 父列表垂直拖拽。子列表水平拖拽
	self.parentDragList = Lua_DragList.new(self.content, 702, 645 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.parentDragList:setListCell(Lua_SingleCopyCell, 702, 160, 1);
	self.parentDragList:setCellSpacing(0, 10);
	self.parentDragList:setRectAnchor(1);
	self.parentDragList:setLocation(0, -828 - self.adaptHeight / 2);
	self.parentDragList.tweenId = 2019;
	self.parentDragList.delayTween = true;

	-- 副本
	self.btnList = Lua_DragList.new(self.content, 702, 119, Lua_AxisDefine.Horizontal);
	self.btnList:setRectAnchor(7);
	self.btnList:setListCell(Lua_SingleBtnItem, 223, 119, 1);
	self.btnList:setLocation(0, 200.5);


	self.firstpassBtn:addClickFuntion(self, self.onRankBtnClick); -- 首通奖励
	self.shopBtn:addClickFuntion(self, self.onShopBtnClick); -- 商店奖励
	self.warBtn:addClickFuntion(self, self.onWarBtnClick); -- 战令
	self.ruleBtn:addClickFuntion(self, self.onHelpBtnClick); -- 规则说明
	self.bossTipsBtn:addClickFuntion(self, self.onBossBtnClick); -- boss攻略
	self.harvestBtn:addClickFuntion(self, self.onHarvestBtnClick); -- 今日收获
	self.addBtn:addClickFuntion(self, self.onAddBtnClick); -- 道具

	self:updateBtnRedPoint();

	self:addLuaEvent("ON_SELECT_COPY_CELL", self, self.updateSelectCopyInfo); -- 副本选中
	self:addLuaEvent("ON_SELECT_DIFF_FIGHT", self, self.onSelectDiffFight); -- 难度挑战

	self:addLuaEvent("EQUIPCOPY_UPDATE_SINGLE_BTNREDPOINT", self, self.updateBtnRedPoint); -- 按钮红点更新
	self:addLuaEvent("EQUIPCOPY_UPDATE_SINGLE_FIRST", self, self.updateSingleFirstRedPoint); -- 首通
	self:addLuaEvent("EQUIP_COPY_INFO", self, self.updateShowInfo);
	self:addLuaEvent("EQUIP_COPY_OPEN_STATE", self, self.updateCopyInfo); -- 副本开启状态更改
end

function Lua_SingleTeamPanel:onScreenResize(adaptHeight)
	if self.adaptHeight ~= adaptHeight then
		self:superCall("onScreenResize", adaptHeight);

		self.parentDragList:setContentRect(702, 645 + adaptHeight);
		self.parentDragList:setLocation(0, -828 - adaptHeight / 2);
		self.parentDragList:moveToIndex(self.toIndex, true, false);
	end
end

function Lua_SingleTeamPanel:updateShowInfo()
	self:updateCopyInfo(true);
end

function Lua_SingleTeamPanel:updateCopyInfo(bOpenState)
	-- 副本
	if bOpenState then
		self.parentDragList.showTween = false;
	else
		self.parentDragList.showTween = true;
	end
	if self.tab_select == nil then
		self.tab_select = DataCenter.equipCopyData.copyOpenId;
	end
	self.btnList:setArrayData(self.campList); 
	self.btnList:setSelected(self.tab_select); 
	self.btnList:moveToIndex(self.tab_select, true, false);
	self:updateSelectCopyInfo(self.campList[self.tab_select], true);

	self.challengeNum.text = LanUtil.formateStr(420001, tostring(DataCenter.equipCopyData.free_times), tostring(DataCenter.equipCopyData.times_limit));
	local num = DataCenter.packData:getItemCountById(DataCenter.equipCopyUtil.single_boss_extra_item[1][1]);
	self.itemNumTxt.text = num;
end

-- 副本选中
function Lua_SingleTeamPanel:updateSelectCopyInfo(data, isChange)
	local diff = DataCenter.equipCopyData:getCopyDifficultyByID(data.id);
	local arr = DataCenter.equipCopyUtil:getSingleCapyDicById(data.id);
	self.parentDragList:setArrayData(arr);
	self.toIndex = diff - 1 < 1 and 1 or diff - 1; -- 除了第一个难度，其他默认上一难度
	self.parentDragList:moveToIndex(self.toIndex, true, false);

	if self.tab_select == data.id and isChange == nil then
		return;
	end
	self.data = data;
	self.tab_select = data.id;

	self.bossNameTxt.text = data.boss_name;
	self.addDesTxt.text = data.des;
	local bossId = DataCenter.equipCopyUtil:getSingleBossIdById(arr[self.toIndex].id);
	self:showBossModel(bossId);
end

-- 模型展示
function Lua_SingleTeamPanel:showBossModel(id)
	Lua_MsgUtil.callFunc("EQUIP_COPY_SHOW_MODEL", id);
end

-- 挑战
function Lua_SingleTeamPanel:onSelectDiffFight(param)
	self.stage_id = param.stage_id;
	self.difficulty = param.difficulty;
	self.monster_player_id = param.monster_player_id;
	local sceneId = DataCenter.heroLineupData:getLineUpSceneId(self.data.lineup);
	DataCenter.preLoadData:preShowScene("Lua_EquipCopyLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
end

function Lua_SingleTeamPanel:onSceneShow(param)
	local list = {
		stage_id = self.stage_id;
		copyData = self.data,
		template_id = DataCenter.equipCopyUtil.single_template_id,
		monster_player_id = self.monster_player_id
	};
	Lua_WindowUtil.openWin("Lua_EquipCopyLineupWindow", Lua_WinParam.ACTION_OPEN, list);
end


-- 道具途获取径
function Lua_SingleTeamPanel:onAddBtnClick()
	local id = DataCenter.equipCopyUtil.single_boss_extra_item[1][1]
	DataCenter.packUtil:openPathWindow(id, false);
end

-- 首通
function Lua_SingleTeamPanel:onRankBtnClick()
	Lua_WindowUtil.openWin("Lua_EquipCopyRankWindow", Lua_WinParam.ACTION_OPEN);
end

-- 商店
function Lua_SingleTeamPanel:onShopBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1044) -- 1044：寂灭商店跳转id
end

-- 战令
function Lua_SingleTeamPanel:onWarBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1042) -- 1042：寂灭岛战令跳转id
end

-- boss攻略
function Lua_SingleTeamPanel:onBossBtnClick()
	Lua_WindowUtil.openWin("Lua_BossStrategyWindow", Lua_WinParam.ACTION_OPEN, {bTeam = false,id = self.tab_select});
end

-- 今日收获
function Lua_SingleTeamPanel:onHarvestBtnClick()
	Lua_WindowUtil.openWin("Lua_HarvestPackWindow", Lua_WinParam.ACTION_OPEN, 1);
end

-- 规则
function Lua_SingleTeamPanel:onHelpBtnClick() 
	local tipsData = {des = LanUtil.getValue(420003), posX = 160, posY = -250};
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

-- 按钮上的红点显示
function Lua_SingleTeamPanel:updateBtnRedPoint()
	if self.warMarkRedPoint == nil then -- 战令红点
		self.warMarkRedPoint = Lua_RedPointIcon.new(self.leftObg);
		self.warMarkRedPoint:createRedPointEff();
		self.warMarkRedPoint:setLocation(-270, 371, 0);
	end
	if self.singleHarvestRedPoint == nil then -- 今日收获红点
		self.singleHarvestRedPoint = Lua_RedPointIcon.new(self.rightObj);
		self.singleHarvestRedPoint:createRedPointEff();
		self.singleHarvestRedPoint:setLocation(338, 473, 0);
	end

	local warMark = DataCenter.equipCopyData.equipCopyWarMarkRedDot; -- 战令
	local singleHarvest = DataCenter.equipCopyData.equipCopySingleHarvestRedDot; -- 今日收获

	self.warMarkRedPoint:updateRedPointShow(warMark);
	self.singleHarvestRedPoint:updateRedPointShow(singleHarvest);
	self:updateSingleFirstRedPoint();
end

-- 首通红点
function Lua_SingleTeamPanel:updateSingleFirstRedPoint()
	if self.firstPassRedPoint == nil then -- 首通红点
		self.firstPassRedPoint = Lua_RedPointIcon.new(self.leftObg);
		self.firstPassRedPoint:createRedPointEff();
		self.firstPassRedPoint:setLocation(-270, 575, 0);
	end
	local firstPass = DataCenter.equipCopyData.firstPassRankRedDot; -- 首通
	self.firstPassRedPoint:updateRedPointShow(firstPass);
end

function Lua_SingleTeamPanel:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.parentDragList ~= nil then
		self.parentDragList:dispose();
		self.parentDragList = nil;
	end
	if self.warMarkRedPoint ~= nil then
		self.warMarkRedPoint:dispose();
		self.warMarkRedPoint = nil;
	end
	if self.firstPassRedPoint ~= nil then
		self.firstPassRedPoint:dispose();
		self.firstPassRedPoint = nil;
	end
	if self.singleHarvestRedPoint ~= nil then
		self.singleHarvestRedPoint:dispose();
		self.singleHarvestRedPoint = nil;
	end
	self.data = nil;
	self.bossModel = nil;

	self:superCall("dispose");
end










-- 副本
Lua_SingleBtnItem = class("Lua_SingleBtnItem", Lua_ListCell);
function Lua_SingleBtnItem:ctor(p)
	self:superCall("ctor", p, "SingleBtnItem_skin");
end

function Lua_SingleBtnItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_SingleBtnItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end
	
	self.itemBg:setUrl(data.camp_bg_path);

	self.copyTitleTxt.text = data.copy_title_name;
	self.copyOtherTxt.text = data.copy_other_name;
	self.rewardTxt.text = data.equip_name;

	self.copyTitleTxt:resetSize();
	self.copyOtherTxt:setLocation(self.copyTitleTxt.posX + self.copyTitleTxt.width + 7.5, 32);

	if DataCenter.equipCopyData:copyOpenStateById(data.id) == false then
		self.desTxt.text = data.open_des;

		self.mask:setEnable(true);
		self.desBg:setEnable(true);
		self.desTxt:setEnable(true);
	else
		self.mask:setEnable(false);
		self.desBg:setEnable(false);
		self.desTxt:setEnable(false);
	end
end

function Lua_SingleBtnItem:onPressClick()
	if self.data == nil then
		return;
	end

	if DataCenter.equipCopyData:copyOpenStateById(self.data.id) == false then
		OperateAlert.showLangValue(420004);
		return;
	end
	Lua_MsgUtil.callFunc("ON_SELECT_COPY_CELL", self.data)
	return true;
end

function Lua_SingleBtnItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);

	self.selectIcon:setEnable(bSelect);
end

function Lua_SingleBtnItem:dispose()
	self.data = nil;
	self:superCall("dispose");
end