Lua_EquipCopyFirstPassRankPanel = class("Lua_EquipCopyFirstPassRankPanel", Lua_DisplayObject)
function Lua_EquipCopyFirstPassRankPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_EquipCopyFirstPassRankPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rankList = Lua_DragList.new(self.content, 629, 614, Lua_AxisDefine.Vertical);
	self.rankList:setListCell(Lua_EquipCopyFirstPassRankItem, 629, 166, 1);
	self.rankList:setCellSpacing(0, 3);
	self.rankList:setLocation(0, -71);
	self.rankList.tweenId = 2029;
	
	local bossNameArr = DataCenter.equipCopyUtil.bossNameArr;
	local arr = Array();
	for i = 1, bossNameArr:getSize() do
		if bossNameArr[i].camp == 1 then
			arr:add({ textStr = bossNameArr[i].boss_name, redPointId = Lua_RedPointList.EquipCopy_FirstPassRank_CampOne });
		elseif bossNameArr[i].camp == 2 then
			arr:add({ textStr = bossNameArr[i].boss_name, redPointId = Lua_RedPointList.EquipCopy_FirstPassRank_CampTwo });
		elseif bossNameArr[i].camp == 3 then
			arr:add({ textStr = bossNameArr[i].boss_name, redPointId = Lua_RedPointList.EquipCopy_FirstPassRank_CampThree });
		elseif bossNameArr[i].camp == 4 then
			arr:add({ textStr = bossNameArr[i].boss_name, redPointId = Lua_RedPointList.EquipCopy_FirstPassRank_CampFour });
		end
	end

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setLocation(0, -423, 0);
	self.btnList:setButtonStyle("equipcopy_atlas_1", "xui_jmd_button_016", "xui_jmd_button_015", 155, 52, 1, 1);
	self.btnList:setButtonText(0, 1, "957E6E", "8F5123", 28, 28, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
	self.btnList:setButtonItem(155, 52);
	self.btnList:setRedPoint(68, 25);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(arr);

	self:addLuaEvent("EQUIP_COPY_FIRSTPASS_RANK", self, self.updatePanel);
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sFirstPassRankInfo();
end

-- 切换boss阵营
function Lua_EquipCopyFirstPassRankPanel:onBtnClick(index)
	if self.bossIndex == index or self.bossIndex == nil then
		return;
	end

	self.bossIndex = index;
	self.rankList.showTween = true;
	self:updatePanel();
end

function Lua_EquipCopyFirstPassRankPanel:updatePanel(isChange)
	if self.bossIndex == nil then
		local camp = DataCenter.equipCopyData.firstPassSelectedCamp;
		self.bossIndex = camp == nil and 1 or camp;
		self.btnList:setSelected(self.bossIndex); 	
	end

	local rankTab = DataCenter.equipCopyData:getFirstPassRankByCamp(self.bossIndex);
	if rankTab == nil then
		return;
	end
	
	self.rankList:setArrayData(rankTab);
	if isChange == nil then
		self.rankList:moveToIndex(1, true);
	end
end

function Lua_EquipCopyFirstPassRankPanel:dispose()
	if self.rankList ~= nil then
		self.rankList:dispose();
		self.rankList = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
    self:superCall("dispose");
end










Lua_EquipCopyFirstPassRankItem = class("Lua_EquipCopyFirstPassRankItem", Lua_ListCell);
function Lua_EquipCopyFirstPassRankItem:ctor(p)
	self:superCall("ctor", p, "EquipCopyFirstPassRankItem_skin");
end

function Lua_EquipCopyFirstPassRankItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardIcon = Lua_ItemIcon.new(self.content);
	self.rewardIcon:setLocation(77, -21);
	self.rewardIcon:setScale(0.7, 0.7);
	self.rewardIcon:setCanClick(false);

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setCanClick(false);
	self.avatarItem:setLocation(-248, -19, 0);
	self.avatarItem:setScale(0.85, 0.85);

	self.receiveButton:addClickFuntion(self, self.onRecBtnClick);
end

function Lua_EquipCopyFirstPassRankItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if data.showRole == nil then
		self.canReceived = false;
		self.avatarItem:setEnable(false);

		self.nameTxt:setLangValue(420046);
		self.nameTxt:setLocation(-188, -21);
		self.noneObj:SetActive(true);
		self.passTimeTxt:setEnable(false);
		self.receiveButton:setEnable(true);
		self.receiveButton:setLangValue(420047);
		self.drawedIcon:setEnable(false);
		self.receiveButton:setStyle(16);
	else
		self.canReceived = data.hasReward ~= 1 and true or false;
		self.avatarItem:setEnable(true);
		self.avatarItem:setRoleDressUp(data.showRole.dress_info);
		self.avatarItem:setRoleLevel(data.showRole.level);

		self.nameTxt.text = data.showRole.name;
		self.nameTxt:setLocation(-188, -1);
		self.passTimeTxt.text = data.time .. LanUtil.getValue(420048);
		self.noneObj:SetActive(false);
		self.passTimeTxt:setEnable(true);

		self.receiveButton:setLangValue(420049);
		self.receiveButton:setStyle(1);
		self.receiveButton:setEnable(data.hasReward ~= 1);
		self.drawedIcon:setEnable(data.hasReward == 1);
	end
		
	self.titleTxt.text = LanUtil.formateStr(420050, convert_arab_to_chinese(data.difficulty));
	self.rewardIcon:setData(data.reward);
end

function Lua_EquipCopyFirstPassRankItem:onPressClick()
	local winPos = LuaUtil.getTouchPosInverseTf(self.mainContent.transform);
	if self.rewardIcon.isActive and self.rewardIcon:checkInBound(winPos.x, winPos.y) then
		self.rewardIcon:onItemClick();
	end

	if self.avatarItem.isActive and self.avatarItem:checkInBound(winPos.x, winPos.y) then
		self:onAvatarClick();
	end
end

function Lua_EquipCopyFirstPassRankItem:onAvatarClick()
	Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleId(self._data.showRole.id, self._data.showRole.server_flag);
end

function Lua_EquipCopyFirstPassRankItem:onRecBtnClick()
	if not self.canReceived then 
		return;
	end
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sReceiveRankRewardInfo(self._data.difficulty, self._data.campId);
end

function Lua_EquipCopyFirstPassRankItem:dispose()
	if self.rewardIcon ~= nil then
		self.rewardIcon:dispose();
		self.rewardIcon = nil;
	end
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end