Lua_EquipCopyTypeRankPanel = class("Lua_EquipCopyTypeRankPanel", Lua_DisplayObject)
function Lua_EquipCopyTypeRankPanel:ctor(p)
	self:superCall("ctor", p); 
end

function Lua_EquipCopyTypeRankPanel:buildShowItem()
	self:superCall("buildShowItem");
	
	self.rankList = Lua_DragList.new(self.content, 629, 614, Lua_AxisDefine.Vertical);
	self.rankList:setListCell(Lua_EquipCopyTypeRankItem, 629, 166, 1);
	self.rankList:setCellSpacing(0, 3);
	self.rankList:setLocation(0, -71);
	self.rankList.tweenId = 2029;

	local bossNameArr = DataCenter.equipCopyUtil.bossNameArr;
	local arr = Array();
	for i = 1, bossNameArr:getSize() do
		arr:add({ textStr = bossNameArr[i].boss_name });
	end

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setLocation(0, -423, 0);
	self.btnList:setButtonStyle("equipcopy_atlas_1", "xui_jmd_button_016", "xui_jmd_button_015", 155, 52, 1, 1);
	self.btnList:setButtonText(0, 1, "957E6E", "8F5123", 28, 28, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
	self.btnList:setButtonItem(155, 52);
	self.btnList:setRedPoint(68, 25);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(arr);

	self:addLuaEvent("SELECT_EQUIP_COPY_CAMP_RANK", self, self.sendMessageToServer); -- 发送消息给服务端
	self:addLuaEvent("EQUIP_COPY_TYPE_RANK", self, self.updatePanel); -- 接收到服务端消息
end

-- 打开界面时，默认打开风boss阵营
function Lua_EquipCopyTypeRankPanel:setData(data)
	self.actType = data; -- 活动类型
	Lua_MsgUtil.callFunc("SELECT_EQUIP_COPY_CAMP_RANK",1); -- 默认首个阵营--水
end

-- 切换boss阵营
function Lua_EquipCopyTypeRankPanel:onBtnClick(index)
	if self.bossIndex == index or self.bossIndex == nil then
		return;
	end

	self.bossIndex = index;
	Lua_MsgUtil.callFunc("SELECT_EQUIP_COPY_CAMP_RANK", index);
end

-- 发送boss阵营请求给服务端
function Lua_EquipCopyTypeRankPanel:sendMessageToServer(camp)
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sTypeRankInfo(camp, self.actType);
end

-- 接收到服务端数据
function Lua_EquipCopyTypeRankPanel:updatePanel()
	if self.bossIndex == nil then
		self.bossIndex = 1;
		self.btnList:setSelected(self.bossIndex);
	end
	self.rankList.showTween = true;
	local rankList = DataCenter.equipCopyData:getTypeCampRankByCamp(self.bossIndex, self.actType);
	self.rankList:setArrayData(rankList);
	-- self.rankList:moveToIndex(1, true);
end

function Lua_EquipCopyTypeRankPanel:dispose()
	if self.rankList ~= nil then
		self.rankList:dispose();
		self.rankList = nil;
	end

    self:superCall("dispose");
end










Lua_EquipCopyTypeRankItem = class("Lua_EquipCopyTypeRankItem", Lua_ListCell);
function Lua_EquipCopyTypeRankItem:ctor(p)
	self:superCall("ctor", p, "EquipCopyTypeRankItem_skin");
end

function Lua_EquipCopyTypeRankItem:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setCanClick(false);
	self.avatarItem:setLocation(-248, -19, 0);
	self.avatarItem:setScale(0.85, 0.85);

	self.hurtBtn:addClickFuntion(self, self.openCalculateHurtWin);
end

function Lua_EquipCopyTypeRankItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if data.showRole == nil then
		self.avatarItem:setEnable(false);

		self.nameTxt:setLangValue(420051);
		self.nameTxt:setLocation(-188, -21);
		self.noneObj:SetActive(true);
		self.desTxt:setEnable(false);
	else
		self.avatarItem:setEnable(true);
		self.avatarItem:setRoleDressUp(data.showRole.dress_info);
		self.avatarItem:setRoleLevel(data.showRole.level);

		self.nameTxt.text = data.showRole.name;
		self.nameTxt:setLocation(-188, -1);
		self.noneObj:SetActive(false);
		self.desTxt:setEnable(true);
	end
	self.hurtBtn:setEnable(data.record_id ~= nil);

	if data.typeRank == Lua_EquipCopyData.ExtremeRound then
		self.titleTxt.text = LanUtil.formateStr(420052, convert_arab_to_chinese(data.difficulty));
		self.desTxt.text = LanUtil.formateStr(420053, data.description);
	elseif data.typeRank == Lua_EquipCopyData.ExtremePower then
		self.titleTxt.text = LanUtil.formateStr(420054, convert_arab_to_chinese(data.difficulty));
		self.desTxt.text = LanUtil.formateStr(420055, data.description);
	end
end

function Lua_EquipCopyTypeRankItem:onPressClick()
	local winPos = LuaUtil.getTouchPosInverseTf(self.mainContent.transform);
	if self.avatarItem.isActive and self.avatarItem:checkInBound(winPos.x, winPos.y) then
		self:onAvatarClick();
	end
end

function Lua_EquipCopyTypeRankItem:onAvatarClick()
	Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleId(self._data.showRole.id, self._data.showRole.server_flag);
end

function Lua_EquipCopyTypeRankItem:openCalculateHurtWin()
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightHurtCollect(self._data.record_id);
end

function Lua_EquipCopyTypeRankItem:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end

	self:superCall("dispose");
end