-- 队伍邀请界面（好友、工会邀请）
Lua_TeamInviteWindow = class("Lua_TeamInviteWindow", Lua_Window);
function Lua_TeamInviteWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TeamInviteWindow";
	self.skinName = "EquipCopyTeamInviteWindow_skin"; 
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_TeamInviteWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.journalContainer = Lua_DragContainer.new(self.content, 632, 614, Lua_AxisDefine.Vertical);
	self.journalContainer:setCellSpacing(0, 3);
	self.journalContainer:setLocation(0, -71);

	self.btnInfo = Array();
	self.btnInfo:add({ textStr = LanUtil.getValue(420067) });
	self.btnInfo:add({ textStr = LanUtil.getValue(420068) });

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setLocation(0, 278, 0);
	self.btnList:setButtonStyle("equipcopy_atlas_1", "xui_jmd_widget_08", "xui_jmd_button_015", 155, 52, 0.01, 1);
	self.btnList:setButtonText(0, 1, "695D58", "8F5123", 28, 28, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
	self.btnList:setButtonLine("equipcopy_atlas_1", "xui_jmd_widget_05", 2, 37, 0, 0, 1);
	self.btnList:setButtonItem(155, 52);
	self.btnList:setRedPoint(64, 15);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(self.btnInfo);

	self.allInviteBtn:addClickFuntion(self, self.onAllInvite);

	self:addLuaEvent("EQUIP_COPY_TEAM_INVITATION_WINDOW", self, self.updatePanel);
	self:addLuaEvent("EQUIP_COPY_TEAM_INVITATION_SENDMESSAGE", self, self.sendMessageToServer);
	self.btnList:setSelected(1); -- 打开时默认好友, 需先注册事件，在onBtnClick中回调
end

function Lua_TeamInviteWindow:showWin(param)
	self:superCall("showWin", param);
end

-- 按下按钮发送消息号
function Lua_TeamInviteWindow:onBtnClick(index)
	self.index = index;
	Lua_MsgUtil.callFunc("EQUIP_COPY_TEAM_INVITATION_SENDMESSAGE", index); -- 1、好友 2、工会  打开时默认好友
end

-- 接收的服务端的数据
function Lua_TeamInviteWindow:updatePanel(isChange)
	local journalList = DataCenter.equipCopyData.teamInvitationArr;
	local count = journalList:getSize();
	self.canInvite = DataCenter.equipCopyData:canInvite();
	self.allInviteBtn:setGray( not DataCenter.roleData:isJoinTheLeague() or not self.canInvite);

	self.journalContainer:clearList();
	-- 处理无好友情况
	if count == 0 then
		self.noneObj:SetActive(true);
		self.journalContainer:setEnable(false);
		if self.index == 1 then
			self.tipsTxt.text =  LanUtil.getValue(420114);
		else
			if not DataCenter.roleData:isJoinTheLeague() then
				OperateAlert.showLangValue(420069);
				self.btnList:setSelected(1);
				self.noneObj:SetActive(false);
			else
				self.tipsTxt.text =  LanUtil.getValue(420115);
			end
		end
		return;
	else
		self.journalContainer:setEnable(true);
		self.noneObj:SetActive(false);
	end

	for i = 1, count do
		self.journalContainer:addSubContainer(Lua_TeamInviteItem, journalList[i], false);
	end

	self.journalContainer:updateChildPos();
	if isChange == nil then
		self.journalContainer:moveToIndex(1, true);
	end
end

-- 发送对应消息号参数给服务端
function Lua_TeamInviteWindow:sendMessageToServer(selectType)
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sInvite(selectType);
end

-- 一键邀请
function Lua_TeamInviteWindow:onAllInvite()
	local journalList = DataCenter.equipCopyData.teamInvitationArr;
	local count = journalList:getSize();
	if count == 0 or not self.canInvite then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sInviteAll(self.index);
end

function Lua_TeamInviteWindow:dispose()
	if self.journalContainer ~= nil then
		self.journalContainer:dispose();
		self.journalContainer = nil;
	end
	if self.btnInfo ~= nil then
		self.btnInfo:dispose();
		self.btnInfo:clear();
		self.btnInfo = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end

	self:superCall("dispose");
end










Lua_TeamInviteItem = class("Lua_TeamInviteItem", Lua_DragContainerItem);
function Lua_TeamInviteItem:ctor(p)
	self:superCall("ctor", p, "EquipCopyTeamInviteItem_skin"); 
end

function Lua_TeamInviteItem:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setLocation(-232, 2, 0);

	self.inviteBtn:addClickFuntion(self, self.onSureInviteBtn);
end

function Lua_TeamInviteItem:setData(data)
	if data == nil then
		return;
	end

	local info = DataCenter.equipCopyData:getTeamInvitationVoById(data);
	self.type = info.type;
	self.roleId = info.showRole.id;
	self.avatarId = info.showRole.head_id;
	self.server_flag = info.showRole.server_flag;
	-- print("self.avatarId = =",self.avatarId)
	self.avatarItem:setRoleDressUp(info.showRole.dress_info);
	self.avatarItem:setRoleLevel(info.showRole.level);
	self.avatarItem:setRoleId(info.showRole.id);

	self.forceTxt.text = info.showRole.force;
	self.playerNameTxt.text = info.showRole.name;

	local canInvite = info.isInvited == 0 and info.isOnline == 1; -- 可以邀请
	self.inviteBtn.label = canInvite and LanUtil.getValue(420070) or (info.isOnline == 0 and LanUtil.getValue(420071) or LanUtil.getValue(420072));
	self.inviteBtn:setStyle(not canInvite and 16 or 1);
end

-- 邀请按钮
function Lua_TeamInviteItem:onSureInviteBtn()
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sInviteJoinTeam(self.roleId, self.type);
end

-- 点击玩家头像
function Lua_TeamInviteItem:onAvatarClick()
	Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleId(self.avatarId, server_flag);
end

function Lua_TeamInviteItem:onPressClick()
	if self.avatarItem == nil then
		return;
	end

	local winPos = LuaUtil.getTouchPosInverseTf(self.mainContent.transform);
	if self.avatarItem.isActive and self.avatarItem:checkInBound(winPos.x, winPos.y) then
		self:onAvatarClick();
	end
end

function Lua_TeamInviteItem:getWidth()
	return 632;
end

function Lua_TeamInviteItem:getHeight()
	return 146;
end

function Lua_TeamInviteItem:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	self:superCall("dispose");
end