-- 队伍日志
Lua_TeamJournalWindow = class("Lua_TeamJournalWindow", Lua_Window)
function Lua_TeamJournalWindow:ctor()
	self:superCall("ctor");

	self.windowName = "EquipCopyTeamJournalWindow";
	self.skinName = "EquipCopyTeamJournalWindow"; 
	self.showBlackMask = true;
end

function Lua_TeamJournalWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.journalContainer = Lua_DragContainer.new(self.content, 640, 740, Lua_AxisDefine.Vertical);
	self.journalContainer:setLocation(0, -48, 0);

	self:addLuaEvent("EQUIP_COPY_TEAM_JOURNAL", self, self.updatePanel);
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sLockLog();
end

function Lua_TeamJournalWindow:updatePanel()
	local journalList = DataCenter.equipCopyData.journalList;
	self.journalContainer:clearList();
	for i = 1, journalList:getSize() do
		self.journalContainer:addSubContainer(Lua_TeamJournalItem, journalList[i], false);
	end
	self.journalContainer:updateChildPos();
	self.journalContainer:moveToIndex(1, true);
end

function Lua_TeamJournalWindow:dispose()
	if self.journalContainer ~= nil then
		self.journalContainer:dispose();
		self.journalContainer = nil;
	end
	self:superCall("dispose");
end










Lua_TeamJournalItem = class("Lua_TeamJournalItem", Lua_DragContainerItem);
function Lua_TeamJournalItem:ctor(p)
	self:superCall("ctor", p, "EquipCopyTeamJournalItem_skin"); 
end

function Lua_TeamJournalItem:buildShowItem()
	self:superCall("buildShowItem");

	self.playBtn:addClickFuntion(self, self.onPlayFightRecord);
end

function Lua_TeamJournalItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.timeTxt.text = data.time;
	self.logContentTxt.text = data.content;
	self.historyTxt.text = data.content;

	-- 当type为nil时，仅显示历史记录，6胜 7败
	self.playBtn:setEnable(data.type == 6 or data.type == 7);
	self.journalObj:SetActive(data.type ~= nil);
	self.historyObj:SetActive(data.type == nil);
end

-- 播放战斗记录
function Lua_TeamJournalItem:onPlayFightRecord()
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightReplay(self._data.recordList[1], nil, nil, nil, 5);
end

function Lua_TeamJournalItem:getWidth()
	return 640;
end

function Lua_TeamJournalItem:getHeight()
	return self._data.type == nil and 70 or 110;
end

function Lua_TeamJournalItem:dispose()
	self:superCall("dispose");
end