-- 创建组队
Lua_CreateTeamWindow = class("Lua_CreateTeamWindow", Lua_Window);
function Lua_CreateTeamWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CreateTeamWindow";
	self.skinName = "CreateTeamWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_CreateTeamWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.teamSet = 0; -- 0：任何可以加入 1：邀请加入
	self.diffSet = nil; -- 难度筛选索引
	self.forceSet = nil; -- 战斗筛选索引
	-- self.fightSet1 = 1; -- 人满自动挑战
	self.fightSet2 = 0; -- 失败在次挑战

	self.joinBox.selected = true;
	self.joinBox:addBoxChange(self, self.onJoinChange);

	self.inviteBox.selected = false;
	self.inviteBox:addBoxChange(self, self.onInviteChange);

	-- self.autoBox.selected = true;
	-- self.autoBox:addBoxChange(self, self.onAutoChange);
	
	self.againBox.selected = false;
	self.againBox:addBoxChange(self, self.onAgainChange);
	
	self.diffBg.clickScale = false;
	self.forceBg.clickScale = false;
	self.diffBg:addClickFuntion(self, self.onDiffBtnClick); -- 难度筛选
	self.forceBg:addClickFuntion(self, self.onForceBtnClick); -- 战力筛选
	self.createBtn:addClickFuntion(self, self.onCreateBtnClick); -- 创建队伍
end

function Lua_CreateTeamWindow:showWin(param)
	self:superCall("showWin", param);

	local max_diff; -- 难度
	local diffIndex; -- 难度筛选索引
	local forceIndex; -- 战斗筛选索引
	self.typev = param;
	if self.typev == 1 then -- 队伍创建
		self.createBtn:setLangValue(420015);
		max_diff = DataCenter.equipCopyData.max_difficulty;
		self.diffScreenInfo, diffIndex = DataCenter.equipCopyUtil:getDiffScreenInfo(max_diff);
		self.forceScreenInfo, forceIndex = DataCenter.equipCopyUtil:forceScreenInfo(nil);
	elseif self.typev == 2 then -- 队伍设置
		self.createBtn:setLangValue(420029);
		max_diff = DataCenter.equipCopyData.max_difficulty;
		local list = DataCenter.equipCopyData.teamMemberDic;
		for k,vo in pairs(list) do
			if vo.difficulty < max_diff then
				max_diff = vo.difficulty;--最小的难度
			end
		end

		self.diffScreenInfo, diffIndex = DataCenter.equipCopyUtil:getDiffScreenInfo(max_diff, DataCenter.equipCopyData.team_diff);
		self.forceScreenInfo, forceIndex = DataCenter.equipCopyUtil:forceScreenInfo(DataCenter.equipCopyData.team_force);

		self.teamSet = DataCenter.equipCopyData.team_join_limit; -- 0：任何可以加入 1：邀请加入
		if self.teamSet == 0 then
			self.joinBox.selected = true;
			self.inviteBox.selected = false;
		else
			self.joinBox.selected = false;
			self.inviteBox.selected = true;
		end

		self.fightSet2 = DataCenter.equipCopyData.fight_set;
		self.againBox.selected = self.fightSet2 == 1;
	end
	self:updateForceLimit(forceIndex);
	self:updateDiffLimit(diffIndex);
end

function Lua_CreateTeamWindow:updateForceLimit(index)
	self.forceIndex = index;
	self.forceSet = self.forceScreenInfo[index].setType; -- 战力设置类型
	self.forcedes.text = self.forceScreenInfo[index].showDes;
end

function Lua_CreateTeamWindow:updateDiffLimit(index)
	self.diffIndex = index;
	self.diffSet = self.diffScreenInfo[index].setType; -- 难度设置类型
	self.diffdes.text = self.diffScreenInfo[index].showDes;
end

-- 难度筛选
function Lua_CreateTeamWindow:onDiffBtnClick()
	self:setDiffIconRot(true);

	local list = {
		owner = self,
		showInfo = self.diffScreenInfo,
		selectIndex = self.diffIndex,
		callBack = self.onDiffCallBack,
		onHideCallBack = self.setDiffIconRot,
		width = 240,
		high = 218,
		x = -153,
		y = -40,
		bgAtlas = "common_altas_1",
		bgSprite = "xui_common_edit_002",
		listWidth = 234,
		listHeight = 200,
		itemHeight = 50,
		bgWidth = 226,
		bgHeight = 50,
		desDic = {fontSize = 26, colorStr = "7A6A5E"}
	};
	Lua_WindowUtil.openWin("Lua_ScreenSelectWindow", Lua_WinParam.ACTION_OPEN, list);
end

function Lua_CreateTeamWindow:setDiffIconRot(state)
	self.difficon:setRot(0, 0, state and 180 or 0);
end

-- 难度
function Lua_CreateTeamWindow:onDiffCallBack(index)
	if self.diffIndex == index then
		return;
	end
	self:updateDiffLimit(index);
end

-- 战力筛选
function Lua_CreateTeamWindow:onForceBtnClick()
	self:setForceIconRot(true);

	local list = {
		owner = self,
		showInfo = self.forceScreenInfo,
		selectIndex = self.forceIndex,
		callBack = self.onForceCallBack,
		onHideCallBack = self.setForceIconRot,
		width = 240,
		high = 208,
		x = -153,
		y = -205,
		bgAtlas = "common_altas_1",
		bgSprite = "xui_common_edit_002",
		listWidth = 234,
		listHeight = 190,
		itemHeight = 50,
		bgWidth = 226,
		bgHeight = 50,
		desDic = {fontSize = 26, colorStr = "7A6A5E"}
	};
	Lua_WindowUtil.openWin("Lua_ScreenSelectWindow", Lua_WinParam.ACTION_OPEN, list);
end

function Lua_CreateTeamWindow:setForceIconRot(state)
	self.forceicon:setRot(0, 0, state and 0 or 180);
end

-- 战力
function Lua_CreateTeamWindow:onForceCallBack(index)
	if self.forceIndex == index then
		return;
	end
	self:updateForceLimit(index);
end

-- 任何人可加入
function Lua_CreateTeamWindow:onJoinChange(bChange)
	if self.teamSet == 0 then
		return;
	end

	if bChange then
		self.teamSet = 0;
		self.inviteBox.selected = false;
	end
	-- print("onJoinChange", bChange, "self.joinBox:",self.joinBox.selected, "self.inviteBox:", self.inviteBox.selected);
end

-- 仅邀请
function Lua_CreateTeamWindow:onInviteChange(bChange)
	if self.teamSet == 1 then
		return;
	end

	if bChange then
		self.teamSet = 1;
		self.joinBox.selected = false;
	end
	-- print("onInviteChange", bChange, "self.joinBox:",self.joinBox.selected, "self.inviteBox:", self.inviteBox.selected);
end

-- 失败再次自动挑战
function Lua_CreateTeamWindow:onAgainChange(bChange)
	if bChange then
		self.fightSet2 = 1;
	else
		self.fightSet2 = 0;
	end
end

-- 创建队伍 战斗设置：0没有选择 1人满自动开始挑战 2失败再次自动挑战 3人满自动挑战和失败再次挑战
function Lua_CreateTeamWindow:onCreateBtnClick()
	if self.typev == 1 then
		-- print(self.teamSet, self.diffSet, self.forceSet, self.fightSet2);
		Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sCreateTeam(self.teamSet, self.diffSet, self.forceSet, self.fightSet2);
	elseif self.typev == 2 then
		if self.teamSet == 0 then--任何人都可以加入
			local str;
			local list = DataCenter.equipCopyData.teamMemberDic;
			for k,vo in pairs(list) do
				if vo.difficulty < self.diffSet or vo.force < self.forceSet then
					if str == nil then
						str = vo.show_role.name;
					else
						str = str..","..vo.show_role.name;
					end
				end
			end
			if str ~= nil then
				OperateAlert.show(LanUtil.formateStr(420107,str));
				return;
			end
		end
		-- print(self.teamSet, self.diffSet, self.forceSet, fightSet);
		Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sChangeTeam(self.teamSet, self.diffSet, self.forceSet, self.fightSet2);
	end
	self:hide();
end

function Lua_CreateTeamWindow:dispose()
	self:superCall("dispose");
end