-- 邀请分享界面
Lua_InviteBtnWindow = class("Lua_InviteBtnWindow", Lua_Window);
function Lua_InviteBtnWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_InviteBtnWindow";
	self.skinName = "InviteBtnWindow_skin";
	self.showBlackMask = true;
	self.blackAlpha = 0.1;
	self.isClickClose = true;
end

function Lua_InviteBtnWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.isShowTime = false;
	self.showTimeTxt:setEnable(false);

	self.shareBtn:addClickFuntion(self, self.onShareBtnClick); -- 分享
	self.inviteBtn:addClickFuntion(self, self.onInviteBtnClick); -- 邀请
	self:addLuaEvent("UPDATE_TEAM_MEMBER_INFO", self, self.updateShowInfo); -- 界面数据
end

function Lua_InviteBtnWindow:showWin(param)
	self:superCall("showWin", param);

	self.isFirst = true;
	self:updateShowInfo();
end

-- 界面数据
function Lua_InviteBtnWindow:updateShowInfo()
	self.overTime = Mathf.Ceil(DataCenter.equipCopyData.last_share_tick - DataCenter.roleData.serverTime);
	self.overTime = self.overTime >= 30 and 0 or self.overTime;
	self.isShowTime = self.overTime >= 0 and self.overTime < 30;
	if self.isShowTime then
	    local time = DataCenter.equipCopyUtil.share_time_limit - self.overTime + 1;
	    self.showTime = self.isFirst and self.overTime or time;
		self.showTimeTxt:setEnable(true);
		self:startTimer();
		self:updateInviteTime();
	end
    self.isFirst = false;
end

-- 开始计时器
function Lua_InviteBtnWindow:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		Lua_CommonUtil.addTimer("Lua_InviteBtnWindow", 1, self, self.updateInviteTime);
	end
end

function Lua_InviteBtnWindow:updateInviteTime()
	self.showTime = self.showTime - 1;
	self.showTimeTxt.text = LanUtil.formateStr(420060, self.showTime);
	if self.showTime <= 0 then
		self:endTimer();
	end
end

function Lua_InviteBtnWindow:endTimer()
	if self.bTimer == true then
		self.bTimer = false;

		self.isShowTime = false;
		self.showTimeTxt:setEnable(false);
		Lua_CommonUtil.removeTimer(self, self.updateInviteTime);
	end
end

-- 分享
function Lua_InviteBtnWindow:onShareBtnClick()
	if DataCenter.equipCopyData.isLeader ~= true then -- 不是队长
		OperateAlert.showLangValue(420061);
		return;
	end

	if self.isShowTime == true then
		-- OperateAlert.show(LanUtil.formateStr(420062, self.showTime));
		return;
	end

	local share_channel = DataCenter.equipCopyUtil.share_channel;
	for i = 1, #share_channel do
		self:sendToChat(share_channel[i]);
	end
	self.isShowTime = true;
	OperateAlert.showLangValue(420063);
end

function Lua_InviteBtnWindow:sendToChat(chatType)
	if chatType == 1 then -- 1世界频道
		if DataCenter.funcOpenData:isOpened(10228) then
			Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sChat(Lua_ChatData.CHANNEL_WORLD,  Lua_ChatData.CONTENT_EQUIP_COPY);
		end
	elseif chatType == 2 then -- 2联盟频道（社区）
		if DataCenter.funcOpenData:isOpened(10229) and DataCenter.roleData.league_id > 0 then
			Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sChat(Lua_ChatData.CHANNEL_LEAGUE,  Lua_ChatData.CONTENT_EQUIP_COPY);
		end
	elseif chatType == 3 then -- 3系统频道
		if DataCenter.funcOpenData:isOpened(10230) and DataCenter.roleData.league_id > 0 then
			Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sChat(Lua_ChatData.CHANNEL_SYSTEM,  Lua_ChatData.CONTENT_EQUIP_COPY);
		end
	elseif chatType == 4 then -- 4私聊频道
		if DataCenter.funcOpenData:isOpened(10231) and DataCenter.roleData.league_id > 0 then
			Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sChat(Lua_ChatData.CHANNEL_FRIEND,  Lua_ChatData.CONTENT_EQUIP_COPY);
		end
	elseif chatType == 5 then -- 5跨服频道
		if DataCenter.funcOpenData:isOpened(10231) and DataCenter.chatData.crossServerState then
			Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sChat(Lua_ChatData.CHANNEL_CROSS_SERVER,  Lua_ChatData.CONTENT_EQUIP_COPY);
		end
	elseif chatType == 6 then -- 6精英赛频道
		if DataCenter.funcOpenData:isOpened(10233) then
			Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sChat(Lua_ChatData.CHANNEL_CHAMPIONSHIP,  Lua_ChatData.CONTENT_EQUIP_COPY);
		end
	elseif chatType == 7 then -- 7巅峰对决频道
		if DataCenter.funcOpenData:isOpened(10234) then
			Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sChat(Lua_ChatData.CHANNEL_PEAKDUEL,  Lua_ChatData.CONTENT_EQUIP_COPY);
		end
	end
end

-- 邀请
function Lua_InviteBtnWindow:onInviteBtnClick()
	Lua_WindowUtil.openWin("Lua_TeamInviteWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_InviteBtnWindow:dispose()
	self:endTimer();
	self:superCall("dispose");
end