-- 队伍成员信息
Lua_TeamItem = class("Lua_TeamItem", Lua_ListCell);
function Lua_TeamItem:ctor(p)
	self:superCall("ctor", p, "TeamItem_skin");
end

function Lua_TeamItem:buildShowItem()
	self:superCall("buildShowItem");

	self.palyerHead = Lua_AvatarItem.new(self.showObj);
	self.palyerHead:setLocation(-280, 60, 0);
	self.palyerHead:setSiblingIndex(0);

	self.bossAvatar = Lua_AvatarItem.new(self.content);
	self.bossAvatar:setAvatarBg("equipcopy_atlas_1", "xui_jmd_widget_26");
	self.bossAvatar:setLocation(265, 60, 0);
	self.bossAvatar:setSiblingIndex(4);
	self.bossAvatar:setAvatarClick(self, self.onBossIconBtnClick);

	self.teamList = Lua_ItemIconList.new(self.showObj);
	self.teamList.scaleVal = 0.8;
	-- self.teamList.canClick = true;
	self.teamList:setLocation(0, -68);
	self.teamList:setLayout(130, 0, 10);

	self.kickBtn:addClickFuntion(self, self.onKickBtnClick); -- 踢出队伍
	self.inviteBtn:addClickFuntion(self, self.onInviteBtnClick); -- 邀请
	self.changeBtn:addClickFuntion(self, self.onChangeBtnClick); -- 换位
end

function Lua_TeamItem:setData(pos)
	self.pos = pos;
	self.data = DataCenter.equipCopyData:getTeamMemberVoByPos(pos);
	if self.data ~= nil then
		self.showObj:SetActive(true);
		self.noneObj:SetActive(false);

		if self.data.isLeader == true then -- 队长
			self.leaderIcon:setEnable(true); -- 队长标识ui
			self.prepareIcon:setEnable(false); -- 准备
			self.kickBtn:setEnable(false);
		else
			self.leaderIcon:setEnable(false);
			self.prepareIcon:setEnable(true);
			self.prepareIcon:setGray(self.data.status == 0); -- 0未准备
			self.kickBtn:setEnable(DataCenter.equipCopyData.isLeader); -- 队长
		end
		self.changeBtn:setEnable(not self.data.isSelf);

		self.nameTxt.text = self.data.show_role.name;
		self.forceTxt.text = self.data.show_role.force;
		if self.data.left_reward_times > 0 then
			self.showNumTxt.text = LanUtil.formateStr(420064, self.data.left_reward_times);
		else
			-- 策划要求不显示协战奖励次数
			-- if self.data.extra_reward_times > 0 then
			-- 	self.showNumTxt.text = LanUtil.formateStr(420065, self.data.extra_reward_times);
			-- else
				self.showNumTxt.text = LanUtil.formateStr(420066, self.data.left_help_times);
			-- end
		end

		-- 头像
		self.palyerHead:setRoleDressUp(self.data.show_role.dress_info);
		self.teamList:setArrayData(self.data.lineupArr);-- 队员
		self.diffNumTxt.text = LanUtil.formateStr(420117, self.data.difficulty);
	else
		self.changeBtn:setEnable(true);
		self.showObj:SetActive(false);
		self.noneObj:SetActive(true);
	end
	
	--boss头像
	local id = DataCenter.equipCopyData.camp_list[pos];
	self.copy_id = getConfig("equip_copy", id, "team_copy_id");--多人组队副本id
	local config = getConfig("equip_copy", self.copy_id);
	if config ~= nil then
		local boosId = config.boss_id;
		local hvo = Lua_HeroVo.new(boosId);
		self.bossAvatar:setAvatar(hvo.avatar_atlas_1, hvo.avatar_sprite_1, 0.8);
		self.campIcon:setAltas("common_altas_2", "xui_common_attribute_"..hvo.campType);
	end
end

-- 踢出队伍
function Lua_TeamItem:onKickBtnClick()
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sKickTeam(self.data.show_role.id);
end

-- 邀请
function Lua_TeamItem:onInviteBtnClick()
	Lua_WindowUtil.openWin("Lua_InviteBtnWindow", Lua_WinParam.ACTION_OPEN, 1);
end

-- boss
function Lua_TeamItem:onBossIconBtnClick()
	Lua_WindowUtil.openWin("Lua_BossStrategyWindow", Lua_WinParam.ACTION_OPEN, {bTeam = false,id = self.copy_id});
end

-- 换位
function Lua_TeamItem:onChangeBtnClick()
	-- print("换位", self.pos);
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sPrewarReadyStatus(0); -- 取消准备
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sExchangePos(self.pos);
end

function Lua_TeamItem:dispose()
	if self.palyerHead ~= nil then
		self.palyerHead:dispose();
		self.palyerHead = nil;
	end
	if self.teamList ~= nil then
		self.teamList:dispose();
		self.teamList = nil;
	end
	self:superCall("dispose");
end










-- 阵容展示
Lua_TeamLineupItem = class("Lua_TeamLineupItem", Lua_ListCell);
function Lua_TeamLineupItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_TeamLineupItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setCanClick(false);
	self.itemIcon:setScale(0.8, 0.8);
end

function Lua_TeamLineupItem:setData(data)
	if data == nil then
		return;
	end

	self.itemIcon:setData(data);
end

function Lua_TeamLineupItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end