-- 自己的队伍
checkRequire("Lua_TeamItem");
Lua_TeamPanel = class("Lua_TeamPanel", Lua_DisplayObject);
function Lua_TeamPanel:ctor(p)
	self:superCall("ctor", p, "TeamPanel_skin");
end

function Lua_TeamPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.forceIndex = 0; -- 战斗筛选索引
	self.prepareBtn:setGray(true);
	self.diffIndex = DataCenter.equipCopyData.max_difficulty; -- 难度筛选索引

	LuaUtil.setObjPos(self.showObj, 0, 0 + Mathf.Abs(self.adaptHeight/2), 0);
	-- 队伍成员列表
	self.teamList = Lua_DragList.new(self.showObj, 704, 830, Lua_AxisDefine.Vertical);
	self.teamList:setListCell(Lua_TeamItem, 704, 259, 1);
	self.teamList:setCellSpacing(0, 10);
	self.teamList:setLocation(0, -30);

	self.setTxt:addClickFuntion(self, self.onSetBtnClick); -- 设置
	self.logBtn:addClickFuntion(self, self.onLogBtnClick); -- 日志
	self.leaveBtn:addClickFuntion(self, self.onLeaveBtnClick); -- 离开
	self.lineupBtn:addClickFuntion(self, self.onLineupBtnClick); -- 布阵
	self.prepareBtn:addClickFuntion(self, self.onPrepareBtnClick); -- 准备

	self:addLuaEvent("EQUIP_COPY_TEAM_INFO", self, self.updateTeamInfo); -- 界面数据
	self:addLuaEvent("UPDATE_TEMA_SET_INFO", self, self.updateTeamSetInfo); -- 更新队伍设置
	self:addLuaEvent("UPDATE_TEAM_STATE_INFO", self, self.updatePrewarReadyInfo); -- 战前准备状态
	self:addLuaEvent("UPDATE_TEAM_MEMBER_INFO", self, self.updateTeamMemberInfo); -- 更新成员信息
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sTeam();
end

function Lua_TeamPanel:onScreenResize(adaptHeight)
	if self.adaptHeight ~= adaptHeight then
		self:superCall("onScreenResize", adaptHeight);
		LuaUtil.setObjPos(self.showObj, 0, 0 + Mathf.Abs(adaptHeight/2), 0);
	end
end

function Lua_TeamPanel:updateShowInfo()
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sTeam();
end

function Lua_TeamPanel:updateTeamInfo()
	self:updateTeamMemberInfo(); -- 成员列表
	self:updateTeamSetInfo();
	self:updatePrewarReadyInfo(); -- 挑战/准备
end

-- 更新队伍设置
function Lua_TeamPanel:updateTeamSetInfo()
	self.bossNameTxt.text = getConfig("equip_copy_more", DataCenter.equipCopyData.team_diff, "boss_name");
	self.forcedesTxt.text = DataCenter.equipCopyUtil:getForceScreenDes(DataCenter.equipCopyData.team_force);
	self.diffdesTxt.text = DataCenter.equipCopyUtil:getDiffScreenDes(DataCenter.equipCopyData.team_diff);
end

-- 更新成员信息
function Lua_TeamPanel:updateTeamMemberInfo()
	-- 队伍成员表
	local arr = Array();
	local isSelf = false;
	local data;
	for i = 1, DataCenter.equipCopyUtil.team_num do
		arr:add(i);

		if not isSelf then
			data = DataCenter.equipCopyData:getTeamMemberVoByPos(i);
			if data ~= nil and data.isSelf then
				isSelf = true;
			end
		end
	end
	self.teamList:setArrayData(arr);

	-- 策划要求改为协战奖励次数
	-- local rewardInfo = DataCenter.equipCopyUtil.more_extra_reward;
	-- local desStr = LanUtil.getValue(420031);
	-- for i = 1, #rewardInfo * 2 do
	-- 	if i % 2 ~= 0 then
	-- 		desStr = desStr .. spliceIconStrById(rewardInfo[(i + 1) / 2][1]);
	-- 	else
	-- 		desStr = desStr .. rewardInfo[i / 2][2];
	-- 	end
	-- end
	-- self.extraRewardTxt.text = desStr;
	-- self.extraRewardTxt:setEnable(data ~= nil and data.left_reward_times <= 0 and data.extra_reward_times > 0);
	local count = DataCenter.equipCopyUtil.more_extra_reward_count;
	if data ~= nil then
		self.extraRewardTxt.text = LanUtil.formateStr(420076, data.extra_reward_times, count);
	else
		self.extraRewardTxt.text = LanUtil.formateStr(420076, count, count);
	end
	self:updatePrewarReadyInfo(); -- 挑战/准备

	self.setTxt:setEnable(DataCenter.equipCopyData.isLeader);
end

-- 战前准备状态更新
function Lua_TeamPanel:updatePrewarReadyInfo()
	if DataCenter.equipCopyData.isLeader == true then -- 队长
		if DataCenter.equipCopyData.fight_start_tick > 0 then -- 已开始挑战倒计时中
			self.prepareBtn:setLangValue(420032);
			self.prepareBtn:setGray(true);
		else
			self.prepareBtn:setLangValue(420033);
			if DataCenter.equipCopyData.isStarFight == true then -- 是否可以挑战
				self.prepareBtn:setGray(false);
			else
				self.prepareBtn:setGray(true);
			end
		end
	else -- 队员
		if DataCenter.equipCopyData.fight_before_state == 1 then -- 战前准备
			self.prepareBtn:setLangValue(420034);
			self.prepareBtn:setGray(true); -- 已准备，置灰
		else
			self.prepareBtn:setLangValue(420035);
			self.prepareBtn:setGray(false); -- 已准备，高亮
		end
	end
	self:starFightTime(); -- 战斗自动开始
end

-- 战斗开始计时器
function Lua_TeamPanel:starFightTime()
	self.overTime = DataCenter.equipCopyData.fight_start_tick;
	if self.overTime > 0 then
		self.fightTimeTxt:setEnable(true);
		Lua_CommonUtil.addTimer("Lua_TeamPanel", 1, self, self.updateTeamFightTime);
		self:updateTeamFightTime();
	else
		self:cancelFightTime();
	end
end

function Lua_TeamPanel:updateTeamFightTime()
	local time = self.overTime - DataCenter.roleData.serverTime;
	self.fightTimeTxt.text = LanUtil.formateStr(420036, time);
	if time <= 0 then
		self:cancelFightTime();
	end
end

function Lua_TeamPanel:cancelFightTime()
	self.fightTimeTxt:setEnable(false);
	Lua_CommonUtil.removeTimer(self, self.updateTeamFightTime);
end

-- 设置
function Lua_TeamPanel:onSetBtnClick()
	Lua_WindowUtil.openWin("Lua_CreateTeamWindow", Lua_WinParam.ACTION_OPEN, 2);
end

-- 日志
function Lua_TeamPanel:onLogBtnClick()
	Lua_WindowUtil.openWin("Lua_TeamJournalWindow", Lua_WinParam.ACTION_OPEN);
end

-- 离开
function Lua_TeamPanel:onLeaveBtnClick()
	if DataCenter.equipCopyData.team_num > 1 then
		local tipsData = { des = LanUtil.getValue(420113), btnType = 1, owner = self, sureFun = self.sendQuitTeam };
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
	else
		self:sendQuitTeam();
	end
end

-- 发送离开队伍
function Lua_TeamPanel:sendQuitTeam()
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sQuitTeam();
end

-- 布阵
function Lua_TeamPanel:onLineupBtnClick()
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sPrewarReadyStatus(0); -- 取消准备

	local bossId = DataCenter.equipCopyData.bossId;
	if bossId == nil then
		return
	end
	self.copyData = getConfig("equip_copy", bossId);
	local sceneId = DataCenter.heroLineupData:getLineUpSceneId(self.copyData.lineup);
	DataCenter.preLoadData:preShowScene("Lua_EquipCopyLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
end

function Lua_TeamPanel:onSceneShow(param)
	local list = {
		copyData = self.copyData,
		template_id = DataCenter.equipCopyUtil.more_template_id,
		monster_player_id = DataCenter.equipCopyData.monster_player_id
	};
	Lua_WindowUtil.openWin("Lua_EquipCopyLineupWindow", Lua_WinParam.ACTION_OPEN, list);
end

-- 准备/挑战
function Lua_TeamPanel:onPrepareBtnClick()
	if DataCenter.equipCopyData.isLeader == true  then -- 队长
		if DataCenter.equipCopyData.fight_start_tick > 0 then -- 已开始挑战倒计时中
			Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sMoreStartFight(2); -- 取消挑战
			self:cancelFightTime();
		else
			if DataCenter.equipCopyData.isStarFight == true then -- 是否可以挑战
				local x = Lua_FightDefine.TEMPLATE_ID_COPY_MORE
				Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sMoreStartFight(1); -- 挑战
			else
				OperateAlert.showLangValue(420037);
			end
		end
	else
		if self.onTimer == nil then
			self.onTimer = DataCenter.roleData.serverTime;
		else
			if DataCenter.roleData.serverTime - self.onTimer < 3 then
				OperateAlert.showLangValue(420038);
				return;
			else
				self.onTimer = nil;
			end
		end

		if DataCenter.equipCopyData.fight_before_state == 1 then -- 已准备
			Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sPrewarReadyStatus(0);
		else
			Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sPrewarReadyStatus(1);
		end
	end
end

function Lua_TeamPanel:dispose()
	if self.teamList ~= nil then 
		self.teamList:dispose();
		self.teamList = nil;
	end
	self:cancelFightTime();

	self:superCall("dispose");
end