-- 寂灭岛组队大厅
checkRequire("Lua_SaloonPanel"); -- 组队大厅
checkRequire("Lua_TeamPanel"); -- 自己队伍
Lua_TeamSaloonWindow = class("Lua_TeamSaloonWindow", Lua_Window);
function Lua_TeamSaloonWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TeamSaloonWindow";
	self.layer = MainWinDefine.MAIN_MENU_TOP_LAYER;
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;
end

function Lua_TeamSaloonWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnListBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_widget_005", 0, 60.5, 720, 121);
	self.btnListBg.anchor = Lua_WindowUtil.getAnchor(7);
	self.btnListBg.siblingIndex = 0;

	self.panelObjTab = {};
	self.tabInfo = Array();
	self.tabInfo:add({panel = Lua_SaloonPanel, redPointId = Lua_RedPointList.EquipCopy_Team_Invite, textAtlas = "equipcopy_atlas_1", textNormalSprite = "xui_jmd_zgnbutton_04_n", textSelectedSprite = "xui_jmd_zgnbutton_04_p"});
	self.tabInfo:add({panel = Lua_TeamPanel, textAtlas = "equipcopy_atlas_1", textNormalSprite = "xui_jmd_zgnbutton_03_n", textSelectedSprite = "xui_jmd_zgnbutton_03_p"});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList.pivot = -1;
	self.btnList:setRectAnchor(7);
	self.btnList:setLocation(252, 59, 0);
	self.btnList:setButtonStyle("common_altas_1", "xui_common_zgnbutton_07", "xui_common_zgnbutton_07", 108, 118, 0.01, 1);
	self.btnList:setButtonLine("common_altas_1", "ui_common_line_011", 2, 108, 0, 0, 1);
	self.btnList:setButtonItem(108, 118);
	self.btnList:setRedPoint(42, 41);
	self.btnList:setClickCallBack(self, self.onTabBtnClick);
	self.btnList:setData(self.tabInfo);

	self:addLuaEvent("EQUIP_COPY_TEAM_INFO", self, self.updateTeamSelect);
end

function Lua_TeamSaloonWindow:showWin(param)
	self:updateTeamSelect();
	self.btnList:setSelected(param);
end

function Lua_TeamSaloonWindow:updateTeamSelect()
	self.btnList:setOpenState(2, DataCenter.equipCopyData.team_id ~= 0);
end

function Lua_TeamSaloonWindow:onTabBtnClick(val)
	if val == 2 and DataCenter.equipCopyData.team_id == 0 then
		OperateAlert.showLangValue(420014);
		return;
	end

	-- 隐藏旧的
	self.panel = self.panelObjTab[self.selectTabIndex];
	if self.panel ~= nil then
		self.panel:setEnable(false);
	end
	self.selectTabIndex = val;

	self.panel = self.panelObjTab[val];
	if self.panelObjTab[val] == nil then
		self.panel = self.tabInfo[val].panel.new(self.content);
		self.panel:setSiblingIndex(0);
		self.panel:setRectAnchor(9);
		self.panelObjTab[val] = self.panel;
	else
		self.panel:setEnable(true);
		self.panel:onScreenResize(self.adaptHeight)
		if self.panel.updateShowInfo ~= nil then
			self.panel:updateShowInfo();
		end
	end
end

function Lua_TeamSaloonWindow:dispose()
	if self.btnListBg ~= nil then
		self.btnListBg:dispose();
		self.btnListBg = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.panelObjTab ~= nil then
		for idx, panel in pairs(self.panelObjTab) do
			panel:dispose();
			self.panelObjTab[idx] = nil;
		end
		self.panelObjTab = nil;
	end
	if self.tabInfo ~= nil then
		self.tabInfo:dispose();
		self.tabInfo:clear();
		self.tabInfo = nil;
	end
	if Lua_WindowUtil.isWindowShowing("Lua_TipsWindow") then
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_CLOSE);
	end
	if Lua_WindowUtil.isWindowShowing("Lua_CreateTeamWindow") then
		Lua_WindowUtil.openWin("Lua_CreateTeamWindow", Lua_WinParam.ACTION_CLOSE);
	end
	self:superCall("dispose");
end